=== modified file 'DBUS-API'
--- DBUS-API	2011-09-18 16:04:23 +0000
+++ DBUS-API	2011-10-02 19:18:24 +0000
@@ -5,7 +5,7 @@
 This file documents the D-Bus interface to the Mandos server.
 
 * Bus: System bus
-  Bus name: "se.bsnet.fukt.Mandos"
+  Bus name: "se.recompile.Mandos"
 
 
 * Object Paths:
@@ -17,7 +17,7 @@
 
   
 * Mandos Server Interface:
-  Interface name: "se.bsnet.fukt.Mandos"
+  Interface name: "se.recompile.Mandos"
   
 ** Methods:
 *** GetAllClients() → (ao: Clients)
@@ -44,7 +44,7 @@
 
 
 * Mandos Client Interface:
-  Interface name: "se.bsnet.fukt.Mandos.Client"
+  Interface name: "se.recompile.Mandos.Client"
   
 ** Methods
 *** Approve(b: Approve) → nothing

=== modified file 'Makefile'
--- Makefile	2011-08-17 22:46:35 +0000
+++ Makefile	2011-10-09 17:36:01 +0000
@@ -5,7 +5,7 @@
 	-Wbad-function-cast -Wcast-qual -Wcast-align -Wwrite-strings \
 	-Wconversion -Wstrict-prototypes -Wold-style-definition \
 	-Wpacked -Wnested-externs -Winline -Wvolatile-register-var
-#	-Wunreachable-code 
+#	-Wunreachable-code
 #DEBUG=-ggdb3
 # For info about _FORTIFY_SOURCE, see
 # <http://www.kernel.org/doc/man-pages/online/pages/man7/feature_test_macros.7.html>
@@ -23,7 +23,7 @@
 OPTIMIZE=-Os
 LANGUAGE=-std=gnu99
 htmldir=man
-version=1.3.1
+version=1.4.0
 SED=sed
 
 ## Use these settings for a traditional /usr/local install

=== modified file 'NEWS'
--- NEWS	2011-07-27 17:58:27 +0000
+++ NEWS	2011-10-09 17:36:01 +0000
@@ -1,6 +1,20 @@
 This NEWS file records noteworthy changes, very tersely.
 See the manual for detailed information.
 
+Version 1.4.0 (2011-10-09)
+* README file migrated to manual page intro(8mandos).
+* Client:
+** Fixed warning about "rmdir: Directory not empty".
+* Server:
+** Default values changed: timeout 5 minutes, interval 2 minutes.
+** Clients gets an expiration extension when receiving a password,
+   controlled by new "extended_timeout" setting.
+** New domain name: "fukt.bsnet.se" changes to "recompile.se".  This
+   also affects the D-Bus bus and interface names (old names still
+   work).  Users should start using the new names immediately.
+** New D-Bus Client object properties "Expires" and "ExtendedTimeout";
+   see DBUS-API for details.
+
 Version 1.3.1 (2011-07-27)
 * Client:
 ** Client now retries all Mandos servers periodically.

=== modified file 'README'
--- README	2011-09-18 14:28:47 +0000
+++ README	2011-10-05 16:00:56 +0000
@@ -1,4 +1,4 @@
-Please see: http://www.fukt.bsnet.se/mandos/man/intro.8mandos
+Please see: http://www.recompile.se/mandos/man/intro.8mandos
 
 This information previously in this file has been moved to the
 intro(8mandos) manual page.  Go to the above URL, or run this command:

=== modified file 'TODO'
--- TODO	2011-09-26 19:36:18 +0000
+++ TODO	2011-10-09 15:21:16 +0000
@@ -16,7 +16,7 @@
 * splashy
 ** TODO [#B] use scandir(3) instead of readdir(3)
 
-* usplash
+* usplash (Deprecated)
 ** TODO [#A] Make it work again
 ** TODO [#B] use scandir(3) instead of readdir(3)
 ** TODO Use [[info:libc:Argz%20Functions][argz_extract]]
@@ -114,8 +114,8 @@
    From XML sources directly?
 
 * Side Stuff
-** TODO Locate which packet move the other bin/sh when busy box is deactivated
-** TODO contact owner of packet, and ask them to have that shell static in position regardless of busybox
+** TODO Locate which package moves the other bin/sh when busybox is deactivated
+** TODO contact owner of package, and ask them to have that shell static in position regardless of busybox
 
 
 #+STARTUP: showall

=== modified file 'common.ent'
--- common.ent	2011-07-27 17:58:27 +0000
+++ common.ent	2011-10-09 17:36:01 +0000
@@ -1,3 +1,3 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!-- Edited by Makefile -->
-<!ENTITY version "1.3.1">
+<!ENTITY version "1.4.0">

=== modified file 'dbus-mandos.conf'
--- dbus-mandos.conf	2009-11-09 07:35:16 +0000
+++ dbus-mandos.conf	2011-10-02 19:18:24 +0000
@@ -7,12 +7,18 @@
     <allow own="se.bsnet.fukt.Mandos"/>
     <allow send_destination="se.bsnet.fukt.Mandos"/>
     <allow receive_sender="se.bsnet.fukt.Mandos"/>
+    <allow own="se.recompile.Mandos"/>
+    <allow send_destination="se.recompile.Mandos"/>
+    <allow receive_sender="se.recompile.Mandos"/>
   </policy>
   
   <policy user="root">
     <allow own="se.bsnet.fukt.Mandos"/>
     <allow send_destination="se.bsnet.fukt.Mandos"/>
     <allow receive_sender="se.bsnet.fukt.Mandos"/>
+    <allow own="se.recompile.Mandos"/>
+    <allow send_destination="se.recompile.Mandos"/>
+    <allow receive_sender="se.recompile.Mandos"/>
   </policy>
 
 </busconfig>

=== modified file 'debian/changelog'
--- debian/changelog	2011-07-27 17:58:27 +0000
+++ debian/changelog	2011-10-09 17:36:01 +0000
@@ -1,3 +1,22 @@
+mandos (1.4.0-1) unstable; urgency=low
+
+  * New upstream release.
+  * Fix "FTBFS with binutils-gold": Added "-Xlinker --as-needed" to
+    LDFLAGS in Makefile. (Closes: #632145)
+  * Fix "/run transition: uses obsolete /dev/.initramfs": Try both old and
+    new PID file locations. (Closes: #643554)
+  * debian/source/local-options: New; contains "--single-debian-patch".
+  * debian/control (Standards-Version): Upgraded to "3.9.2".
+    (DM-Upload-Allowed): New; set to "yes".
+  * debian/control: Changed domain from "fukt.bsnet.se" to "recompile.se".
+  * debian/copyright: - '' -
+  * debian/mandos-client.README.Debian: - '' -
+  * debian/mandos.README.Debian: - '' -
+  * debian/watch: - '' -
+  * debian/control (mandos/Description): Fix language to placate lintian.
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Sun, 09 Oct 2011 19:15:08 +0200
+
 mandos (1.3.1-1) unstable; urgency=low
 
   * New upstream release.

=== modified file 'debian/control'
--- debian/control	2011-09-18 15:03:26 +0000
+++ debian/control	2011-10-10 20:29:58 +0000
@@ -1,16 +1,17 @@
 Source: mandos
 Section: admin
 Priority: extra
-Maintainer: Mandos Maintainers <mandos@fukt.bsnet.se>
-Uploaders: Teddy Hogeborn <teddy@fukt.bsnet.se>,
-	   Björn Påhlsson <belorn@fukt.bsnet.se>
+Maintainer: Mandos Maintainers <mandos@recompile.se>
+Uploaders: Teddy Hogeborn <teddy@recompile.se>,
+	   Björn Påhlsson <belorn@recompile.se>
 Build-Depends: debhelper (>= 7), docbook-xml, docbook-xsl,
 	libavahi-core-dev, libgpgme11-dev, libgnutls-dev, xsltproc,
 	pkg-config
-Standards-Version: 3.9.1
-Vcs-Bzr: http://ftp.fukt.bsnet.se/pub/mandos/trunk
-Vcs-Browser: http://bzr.fukt.bsnet.se/loggerhead/mandos/trunk/files
-Homepage: http://www.fukt.bsnet.se/mandos
+Standards-Version: 3.9.2
+Vcs-Bzr: http://ftp.recompile.se/pub/mandos/trunk
+Vcs-Browser: http://bzr.recompile.se/loggerhead/mandos/trunk/files
+Homepage: http://www.recompile.se/mandos
+DM-Upload-Allowed: yes
 
 Package: mandos
 Architecture: all
@@ -37,7 +38,7 @@
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, cryptsetup,
 	gnupg (<< 2)
-Conflicts: dropbear (<= 0.52-5)
+Breaks: dropbear (<= 0.53.1-1)
 Enhances: cryptsetup
 Description: do unattended reboots with an encrypted root file system
  This is the client part of the Mandos system, which allows

=== modified file 'debian/copyright'
--- debian/copyright	2011-02-27 17:26:35 +0000
+++ debian/copyright	2011-10-10 20:29:58 +0000
@@ -1,8 +1,7 @@
-Format-Specification:
- http://wiki.debian.org/Proposals/CopyrightFormat?action=recall&rev=233
+Format: http://anonscm.debian.org/viewvc/dep/web/deps/dep5.mdwn?revision=202
 Upstream-Name: Mandos
-Upstream-Maintainer: Mandos Maintainers <mandos@fukt.bsnet.se>
-Upstream-Source: <http://www.fukt.bsnet.se/mandos>
+Upstream-Contact: Mandos <mandos@recompile.se>
+Source: <http://www.recompile.se/mandos>
 
 Files: *
 Copyright: Copyright © 2008-2011 Teddy Hogeborn

=== modified file 'debian/mandos-client.README.Debian'
--- debian/mandos-client.README.Debian	2010-09-27 17:53:53 +0000
+++ debian/mandos-client.README.Debian	2011-10-05 16:00:56 +0000
@@ -1,25 +1,3 @@
-* Choose the Client Network Interface
-  
-  Please make sure that the correct network interface is specified in
-  the DEVICE setting in the "/etc/initramfs-tools/initramfs.conf"
-  file.  If the setting is empty, the interface will be autodetected
-  at boot time, which may not be correct.  *If* the DEVICE setting is
-  changed, it will be necessary to update the initrd image by running
-  the command
-  
-	update-initramfs -k all -u
-  
-  The device can be overridden at boot time on the Linux kernel
-  command line using the sixth colon-separated field of the "ip="
-  option; for exact syntax, read the documentation in the file
-  "/usr/share/doc/linux-doc-*/Documentation/filesystems/nfsroot.txt",
-  available in the "linux-doc-*" package.
-  
-  Note that since this network interface is used in the initial RAM
-  disk environment, the network interface *must* exist at that stage.
-  Thus, the interface can *not* be a pseudo-interface such as "br0" or
-  "tun0"; instead, a real interface (such as "eth0") must be used.
-
 * Adding a Client Password to the Server
   
   The server must be given a password to give back to the client on
@@ -46,6 +24,34 @@
   it, and output it to standard output.  There it can be verified to
   be the correct password, before rebooting.
 
+* Emergency Escape
+  
+  If it ever should be necessary, the Mandos client can be temporarily
+  prevented from running at startup by passing the parameter
+  "mandos=off" to the kernel.
+
+* Specifying a Client Network Interface
+  
+  At boot time the network interface to use will by default be
+  automatically detected.  If should result in an incorrect interface,
+  edit the DEVICE setting in the "/etc/initramfs-tools/initramfs.conf"
+  file.  (The default setting is empty, meaning to autodetect the
+  interface.)  *If* the DEVICE setting is changed, it will be
+  necessary to update the initrd image by running the command
+  
+	update-initramfs -k all -u
+  
+  The device can be overridden at boot time on the Linux kernel
+  command line using the sixth colon-separated field of the "ip="
+  option; for exact syntax, read the documentation in the file
+  "/usr/share/doc/linux-doc-*/Documentation/filesystems/nfsroot.txt",
+  available in the "linux-doc-*" package.
+  
+  Note that since this network interface is used in the initial RAM
+  disk environment, the network interface *must* exist at that stage.
+  Thus, the interface can *not* be a pseudo-interface such as "br0" or
+  "tun0"; instead, only real interface (such as "eth0") can be used.
+
 * User-Supplied Plugins
   
   Any plugins found in "/etc/mandos/plugins.d" will override and add
@@ -62,19 +68,14 @@
   Mandos client will be the new default way for getting a password for
   the root file system when booting.
 
-* Emergency Escape
-  
-  If it ever should be necessary, the Mandos client can be temporarily
-  prevented from running at startup by passing the parameter
-  "mandos=off" to the kernel.
-
 * Non-local Connection (Not Using ZeroConf)
   
   If the "ip=" kernel command line option is used to specify a
   complete IP address and device name, as noted above, it then becomes
   possible to specify a specific IP address and port to connect to,
   instead of using ZeroConf.  The syntax for doing this is
-  "mandos=connect:<IP_ADDRESS>:<PORT_NUMBER>".
+  "mandos=connect:<IP_ADDRESS>:<PORT_NUMBER>" on the kernel command
+  line.
   
   For very advanced users, it it possible to specify simply
   "mandos=connect" on the kernel command line to make the system only
@@ -83,4 +84,4 @@
   work, "--options-for=mandos-client:--connect=<ADDRESS>:<PORT>" needs
   to be manually added to the file "/etc/mandos/plugin-runner.conf".
 
- -- Teddy Hogeborn <teddy@fukt.bsnet.se>, Mon, 27 Sep 2010 19:53:21 +0200
+ -- Teddy Hogeborn <teddy@recompile.se>, Wed,  5 Oct 2011 17:50:22 +0200

=== modified file 'debian/mandos-client.postinst'
--- debian/mandos-client.postinst	2009-05-24 23:36:15 +0000
+++ debian/mandos-client.postinst	2011-10-10 20:29:58 +0000
@@ -1,4 +1,4 @@
-#!/bin/sh -e
+#!/bin/sh
 # This script can be called in the following ways:
 #
 # After the package was installed:
@@ -15,6 +15,8 @@
 # If prerm fails during replacement due to conflict:
 #       <postinst> abort-remove in-favour <new-package> <version>
 
+set -e
+
 # Update the initial RAM file system image
 update_initramfs()
 {

=== modified file 'debian/mandos-client.postrm'
--- debian/mandos-client.postrm	2011-02-27 17:00:41 +0000
+++ debian/mandos-client.postrm	2011-10-10 20:29:58 +0000
@@ -1,4 +1,4 @@
-#!/bin/sh -e
+#!/bin/sh
 # This script can be called in the following ways:
 #
 # After the package was removed:
@@ -26,6 +26,7 @@
 # If preinst fails during upgrade:
 #       <new-postrm> abort-upgrade <old-version>
 
+set -e
 
 # Update the initial RAM file system image
 update_initramfs()

=== modified file 'debian/mandos.README.Debian'
--- debian/mandos.README.Debian	2009-09-08 06:28:20 +0000
+++ debian/mandos.README.Debian	2011-10-05 16:00:56 +0000
@@ -1,10 +1,10 @@
 The Mandos server is useless without at least one configured client in
 /etc/mandos/clients.conf.  To create one, install the "mandos-client"
-package on a client computer, and run the command
+package on a client computer, and, on the client, run the command
 
 	# mandos-keygen --password
 
-there to get a config file stanza.  Append the output of that command
-to the file "/etc/mandos/clients.conf" on the Mandos server.
+to get a config file stanza.  Append the output of that command to the
+file "/etc/mandos/clients.conf" on the Mandos server computer.
 
- -- Teddy Hogeborn <teddy@fukt.bsnet.se>, Tue,  8 Sep 2009 06:57:45 +0200
+ -- Teddy Hogeborn <teddy@recompile.se>, Wed,  5 Oct 2011 17:51:22 +0200

=== modified file 'debian/mandos.postinst'
--- debian/mandos.postinst	2009-05-24 23:28:04 +0000
+++ debian/mandos.postinst	2011-10-10 20:29:58 +0000
@@ -1,4 +1,4 @@
-#!/bin/sh -e
+#!/bin/sh
 # This script can be called in the following ways:
 #
 # After the package was installed:
@@ -15,6 +15,8 @@
 # If prerm fails during replacement due to conflict:
 #       <postinst> abort-remove in-favour <new-package> <version>
 
+set -e
+
 case "$1" in
     configure)
 	# Rename old "mandos" user and group

=== modified file 'debian/mandos.prerm'
--- debian/mandos.prerm	2009-01-18 00:16:57 +0000
+++ debian/mandos.prerm	2011-10-10 20:29:58 +0000
@@ -1,4 +1,4 @@
-#! /bin/sh
+#!/bin/sh
 # prerm script for mandos
 #
 # see: dh_installdeb(1)

=== added file 'debian/source/local-options'
--- debian/source/local-options	1970-01-01 00:00:00 +0000
+++ debian/source/local-options	2011-10-08 21:13:46 +0000
@@ -0,0 +1,1 @@
+--single-debian-patch

=== modified file 'debian/watch'
--- debian/watch	2010-09-15 17:17:46 +0000
+++ debian/watch	2011-10-05 16:00:56 +0000
@@ -1,2 +1,2 @@
 version=3
-ftp://ftp.fukt.bsnet.se/pub/mandos/mandos[-_]([^\s]+?)(?:\.orig)?\.tar\.(?:gz|bz2|7z|xz)
+ftp://ftp.recompile.se/pub/mandos/mandos[-_]([^\s]+?)(?:\.orig)?\.tar\.(?:gz|bz2|7z|xz)

=== modified file 'init.d-mandos'
--- init.d-mandos	2009-09-16 23:28:39 +0000
+++ init.d-mandos	2011-10-05 16:00:56 +0000
@@ -9,8 +9,8 @@
 # Description:       Gives encrypted passwords to Mandos clients
 ### END INIT INFO
 
-# Author: Teddy Hogeborn <teddy@fukt.bsnet.se>
-# Author: Björn Påhlsson <belorn@fukt.bsnet.se>
+# Author: Teddy Hogeborn <teddy@recompile.se>
+# Author: Björn Påhlsson <belorn@recompile.se>
 #
 # Please remove the "Author" lines above and replace them
 # with your own name if you copy and modify this script.

=== modified file 'initramfs-tools-hook'
--- initramfs-tools-hook	2010-09-09 18:16:14 +0000
+++ initramfs-tools-hook	2011-10-05 16:56:06 +0000
@@ -131,7 +131,7 @@
 	"${DESTDIR}${CONFDIR}/plugin-runner.conf"
 fi
 
-# Key files 
+# Key files
 for file in "$keydir"/*; do
     if [ -d "$file" ]; then
 	continue

=== modified file 'intro.xml'
--- intro.xml	2011-08-08 21:12:37 +0000
+++ intro.xml	2011-10-05 16:00:56 +0000
@@ -1,7 +1,7 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
-<!ENTITY TIMESTAMP "2011-08-08">
+<!ENTITY TIMESTAMP "2011-10-03">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -18,14 +18,14 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@fukt.bsnet.se</email>
+	  <email>belorn@recompile.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@fukt.bsnet.se</email>
+	  <email>teddy@recompile.se</email>
 	</address>
       </author>
     </authorgroup>
@@ -392,7 +392,7 @@
     <variablelist>
       <varlistentry>
 	<term>
-	  <ulink url="http://www.fukt.bsnet.se/mandos">Mandos</ulink>
+	  <ulink url="http://www.recompile.se/mandos">Mandos</ulink>
 	</term>
 	<listitem>
 	  <para>

=== modified file 'mandos'
--- mandos	2011-09-26 21:06:14 +0000
+++ mandos	2011-10-10 20:29:58 +0000
@@ -28,7 +28,7 @@
 # along with this program.  If not, see
 # <http://www.gnu.org/licenses/>.
 # 
-# Contact the authors at <mandos@fukt.bsnet.se>.
+# Contact the authors at <mandos@recompile.se>.
 # 
 
 from __future__ import (division, absolute_import, print_function,
@@ -62,6 +62,7 @@
 import functools
 import cPickle as pickle
 import multiprocessing
+import types
 
 import dbus
 import dbus.service
@@ -82,7 +83,7 @@
         SO_BINDTODEVICE = None
 
 
-version = "1.3.1"
+version = "1.4.0"
 
 #logger = logging.getLogger('mandos')
 logger = logging.Logger('mandos')
@@ -159,7 +160,8 @@
                             " after %i retries, exiting.",
                             self.rename_count)
             raise AvahiServiceError("Too many renames")
-        self.name = unicode(self.server.GetAlternativeServiceName(self.name))
+        self.name = unicode(self.server
+                            .GetAlternativeServiceName(self.name))
         logger.info("Changing Zeroconf service name to %r ...",
                     self.name)
         syslogger.setFormatter(logging.Formatter
@@ -320,7 +322,7 @@
     
     def extended_timeout_milliseconds(self):
         "Return the 'extended_timeout' attribute in milliseconds"
-        return _timedelta_to_milliseconds(self.extended_timeout)    
+        return _timedelta_to_milliseconds(self.extended_timeout)
     
     def interval_milliseconds(self):
         "Return the 'interval' attribute in milliseconds"
@@ -360,7 +362,8 @@
         self.last_enabled = None
         self.last_checked_ok = None
         self.timeout = string_to_delta(config["timeout"])
-        self.extended_timeout = string_to_delta(config["extended_timeout"])
+        self.extended_timeout = string_to_delta(config
+                                                ["extended_timeout"])
         self.interval = string_to_delta(config["interval"])
         self.disable_hook = disable_hook
         self.checker = None
@@ -379,13 +382,15 @@
             config["approval_delay"])
         self.approval_duration = string_to_delta(
             config["approval_duration"])
-        self.changedstate = multiprocessing_manager.Condition(multiprocessing_manager.Lock())
+        self.changedstate = (multiprocessing_manager
+                             .Condition(multiprocessing_manager
+                                        .Lock()))
     
     def send_changedstate(self):
         self.changedstate.acquire()
         self.changedstate.notify_all()
         self.changedstate.release()
-        
+    
     def enable(self):
         """Start this client's checker and timeout hooks"""
         if getattr(self, "enabled", False):
@@ -460,10 +465,10 @@
             timeout = self.timeout
         self.last_checked_ok = datetime.datetime.utcnow()
         gobject.source_remove(self.disable_initiator_tag)
+        self.disable_initiator_tag = (gobject.timeout_add
+                                      (_timedelta_to_milliseconds
+                                       (timeout), self.disable))
         self.expires = datetime.datetime.utcnow() + timeout
-        self.disable_initiator_tag = (gobject.timeout_add
-                                      (_timedelta_to_milliseconds(timeout),
-                                       self.disable))
     
     def need_approval(self):
         self.last_approval_request = datetime.datetime.utcnow()
@@ -626,24 +631,22 @@
     def _get_all_dbus_properties(self):
         """Returns a generator of (name, attribute) pairs
         """
-        return ((prop._dbus_name, prop)
+        return ((prop.__get__(self)._dbus_name, prop.__get__(self))
+                for cls in self.__class__.__mro__
                 for name, prop in
-                inspect.getmembers(self, self._is_dbus_property))
+                inspect.getmembers(cls, self._is_dbus_property))
     
     def _get_dbus_property(self, interface_name, property_name):
         """Returns a bound method if one exists which is a D-Bus
         property with the specified name and interface.
         """
-        for name in (property_name,
-                     property_name + "_dbus_property"):
-            prop = getattr(self, name, None)
-            if (prop is None
-                or not self._is_dbus_property(prop)
-                or prop._dbus_name != property_name
-                or (interface_name and prop._dbus_interface
-                    and interface_name != prop._dbus_interface)):
-                continue
-            return prop
+        for cls in  self.__class__.__mro__:
+            for name, value in (inspect.getmembers
+                                (cls, self._is_dbus_property)):
+                if (value._dbus_name == property_name
+                    and value._dbus_interface == interface_name):
+                    return value.__get__(self)
+        
         # No such property
         raise DBusPropertyNotFound(self.dbus_object_path + ":"
                                    + interface_name + "."
@@ -758,6 +761,102 @@
     return dbus.String(dt.isoformat(),
                        variant_level=variant_level)
 
+class AlternateDBusNamesMetaclass(DBusObjectWithProperties
+                                  .__metaclass__):
+    """Applied to an empty subclass of a D-Bus object, this metaclass
+    will add additional D-Bus attributes matching a certain pattern.
+    """
+    def __new__(mcs, name, bases, attr):
+        # Go through all the base classes which could have D-Bus
+        # methods, signals, or properties in them
+        for base in (b for b in bases
+                     if issubclass(b, dbus.service.Object)):
+            # Go though all attributes of the base class
+            for attrname, attribute in inspect.getmembers(base):
+                # Ignore non-D-Bus attributes, and D-Bus attributes
+                # with the wrong interface name
+                if (not hasattr(attribute, "_dbus_interface")
+                    or not attribute._dbus_interface
+                    .startswith("se.recompile.Mandos")):
+                    continue
+                # Create an alternate D-Bus interface name based on
+                # the current name
+                alt_interface = (attribute._dbus_interface
+                                 .replace("se.recompile.Mandos",
+                                          "se.bsnet.fukt.Mandos"))
+                # Is this a D-Bus signal?
+                if getattr(attribute, "_dbus_is_signal", False):
+                    # Extract the original non-method function by
+                    # black magic
+                    nonmethod_func = (dict(
+                            zip(attribute.func_code.co_freevars,
+                                attribute.__closure__))["func"]
+                                      .cell_contents)
+                    # Create a new, but exactly alike, function
+                    # object, and decorate it to be a new D-Bus signal
+                    # with the alternate D-Bus interface name
+                    new_function = (dbus.service.signal
+                                    (alt_interface,
+                                     attribute._dbus_signature)
+                                    (types.FunctionType(
+                                nonmethod_func.func_code,
+                                nonmethod_func.func_globals,
+                                nonmethod_func.func_name,
+                                nonmethod_func.func_defaults,
+                                nonmethod_func.func_closure)))
+                    # Define a creator of a function to call both the
+                    # old and new functions, so both the old and new
+                    # signals gets sent when the function is called
+                    def fixscope(func1, func2):
+                        """This function is a scope container to pass
+                        func1 and func2 to the "call_both" function
+                        outside of its arguments"""
+                        def call_both(*args, **kwargs):
+                            """This function will emit two D-Bus
+                            signals by calling func1 and func2"""
+                            func1(*args, **kwargs)
+                            func2(*args, **kwargs)
+                        return call_both
+                    # Create the "call_both" function and add it to
+                    # the class
+                    attr[attrname] = fixscope(attribute,
+                                              new_function)
+                # Is this a D-Bus method?
+                elif getattr(attribute, "_dbus_is_method", False):
+                    # Create a new, but exactly alike, function
+                    # object.  Decorate it to be a new D-Bus method
+                    # with the alternate D-Bus interface name.  Add it
+                    # to the class.
+                    attr[attrname] = (dbus.service.method
+                                      (alt_interface,
+                                       attribute._dbus_in_signature,
+                                       attribute._dbus_out_signature)
+                                      (types.FunctionType
+                                       (attribute.func_code,
+                                        attribute.func_globals,
+                                        attribute.func_name,
+                                        attribute.func_defaults,
+                                        attribute.func_closure)))
+                # Is this a D-Bus property?
+                elif getattr(attribute, "_dbus_is_property", False):
+                    # Create a new, but exactly alike, function
+                    # object, and decorate it to be a new D-Bus
+                    # property with the alternate D-Bus interface
+                    # name.  Add it to the class.
+                    attr[attrname] = (dbus_service_property
+                                      (alt_interface,
+                                       attribute._dbus_signature,
+                                       attribute._dbus_access,
+                                       attribute
+                                       ._dbus_get_args_options
+                                       ["byte_arrays"])
+                                      (types.FunctionType
+                                       (attribute.func_code,
+                                        attribute.func_globals,
+                                        attribute.func_name,
+                                        attribute.func_defaults,
+                                        attribute.func_closure)))
+        return type.__new__(mcs, name, bases, attr)
 
 class ClientDBus(Client, DBusObjectWithProperties):
     """A Client class using D-Bus
@@ -789,27 +888,29 @@
     def notifychangeproperty(transform_func,
                              dbus_name, type_func=lambda x: x,
                              variant_level=1):
-        """ Modify a variable so that its a property that announce its
-        changes to DBus.
-        transform_fun: Function that takes a value and transform it to
-                       DBus type.
-        dbus_name: DBus name of the variable
+        """ Modify a variable so that it's a property which announces
+        its changes to DBus.
+
+        transform_fun: Function that takes a value and transforms it
+                       to a D-Bus type.
+        dbus_name: D-Bus name of the variable
         type_func: Function that transform the value before sending it
-                   to DBus
-        variant_level: DBus variant level. default: 1
+                   to the D-Bus.  Default: no transform
+        variant_level: D-Bus variant level.  Default: 1
         """
-        real_value = [None,]
+        attrname = "_{0}".format(dbus_name)
         def setter(self, value):
-            old_value = real_value[0]
-            real_value[0] = value
             if hasattr(self, "dbus_object_path"):
-                if type_func(old_value) != type_func(real_value[0]):
-                    dbus_value = transform_func(type_func(real_value[0]),
+                if (not hasattr(self, attrname) or
+                    type_func(getattr(self, attrname, None))
+                    != type_func(value)):
+                    dbus_value = transform_func(type_func(value),
                                                 variant_level)
                     self.PropertyChanged(dbus.String(dbus_name),
                                          dbus_value)
+            setattr(self, attrname, value)
         
-        return property(lambda self: real_value[0], setter)
+        return property(lambda self: getattr(self, attrname), setter)
     
     
     expires = notifychangeproperty(datetime_to_dbus, "Expires")
@@ -820,24 +921,32 @@
     last_enabled = notifychangeproperty(datetime_to_dbus,
                                         "LastEnabled")
     checker = notifychangeproperty(dbus.Boolean, "CheckerRunning",
-                                   type_func = lambda checker: checker is not None)
+                                   type_func = lambda checker:
+                                       checker is not None)
     last_checked_ok = notifychangeproperty(datetime_to_dbus,
                                            "LastCheckedOK")
-    last_approval_request = notifychangeproperty(datetime_to_dbus,
-                                                 "LastApprovalRequest")
+    last_approval_request = notifychangeproperty(
+        datetime_to_dbus, "LastApprovalRequest")
     approved_by_default = notifychangeproperty(dbus.Boolean,
                                                "ApprovedByDefault")
-    approval_delay = notifychangeproperty(dbus.UInt16, "ApprovalDelay",
-                                          type_func = _timedelta_to_milliseconds)
-    approval_duration = notifychangeproperty(dbus.UInt16, "ApprovalDuration",
-                                             type_func = _timedelta_to_milliseconds)
+    approval_delay = notifychangeproperty(dbus.UInt16,
+                                          "ApprovalDelay",
+                                          type_func =
+                                          _timedelta_to_milliseconds)
+    approval_duration = notifychangeproperty(
+        dbus.UInt16, "ApprovalDuration",
+        type_func = _timedelta_to_milliseconds)
     host = notifychangeproperty(dbus.String, "Host")
     timeout = notifychangeproperty(dbus.UInt16, "Timeout",
-                                   type_func = _timedelta_to_milliseconds)
-    extended_timeout = notifychangeproperty(dbus.UInt16, "ExtendedTimeout",
-                                            type_func = _timedelta_to_milliseconds)
-    interval = notifychangeproperty(dbus.UInt16, "Interval",
-                                    type_func = _timedelta_to_milliseconds)
+                                   type_func =
+                                   _timedelta_to_milliseconds)
+    extended_timeout = notifychangeproperty(
+        dbus.UInt16, "ExtendedTimeout",
+        type_func = _timedelta_to_milliseconds)
+    interval = notifychangeproperty(dbus.UInt16,
+                                    "Interval",
+                                    type_func =
+                                    _timedelta_to_milliseconds)
     checker_command = notifychangeproperty(dbus.String, "Checker")
     
     del notifychangeproperty
@@ -897,7 +1006,7 @@
     
     
     ## D-Bus methods, signals & properties
-    _interface = "se.bsnet.fukt.Mandos.Client"
+    _interface = "se.recompile.Mandos.Client"
     
     ## Signals
     
@@ -1089,7 +1198,8 @@
             self.disable()
         else:
             self.expires = (datetime.datetime.utcnow()
-                            + datetime.timedelta(milliseconds = time_to_die))
+                            + datetime.timedelta(milliseconds =
+                                                 time_to_die))
             self.disable_initiator_tag = (gobject.timeout_add
                                           (time_to_die, self.disable))
     
@@ -1174,6 +1284,8 @@
             return super(ProxyClient, self).__setattr__(name, value)
         self._pipe.send(('setattr', name, value))
 
+class ClientDBusTransitional(ClientDBus):
+    __metaclass__ = AlternateDBusNamesMetaclass
 
 class ClientHandler(socketserver.BaseRequestHandler, object):
     """A class to handle client connections.
@@ -1259,7 +1371,7 @@
                                        client.name)
                         if self.server.use_dbus:
                             # Emit D-Bus signal
-                            client.Rejected("Disabled")                    
+                            client.Rejected("Disabled")
                         return
                     
                     if client._approved or not client.approval_delay:
@@ -1282,10 +1394,11 @@
                         return
                     
                     #wait until timeout or approved
-                    #x = float(client._timedelta_to_milliseconds(delay))
                     time = datetime.datetime.now()
                     client.changedstate.acquire()
-                    client.changedstate.wait(float(client._timedelta_to_milliseconds(delay) / 1000))
+                    (client.changedstate.wait
+                     (float(client._timedelta_to_milliseconds(delay)
+                            / 1000)))
                     client.changedstate.release()
                     time2 = datetime.datetime.now()
                     if (time2 - time) >= delay:
@@ -1315,7 +1428,7 @@
                     sent_size += sent
                 
                 logger.info("Sending secret to %s", client.name)
-                # bump the timeout as if seen
+                # bump the timeout using extended_timeout
                 client.checked_ok(client.extended_timeout)
                 if self.server.use_dbus:
                     # Emit D-Bus signal
@@ -1401,11 +1514,14 @@
         except:
             self.handle_error(request, address)
         self.close_request(request)
-            
+    
     def process_request(self, request, address):
         """Start a new process to process the request."""
-        multiprocessing.Process(target = self.sub_process_main,
-                                args = (request, address)).start()
+        proc = multiprocessing.Process(target = self.sub_process_main,
+                                       args = (request,
+                                               address))
+        proc.start()
+        return proc
 
 
 class MultiprocessingMixInWithPipe(MultiprocessingMixIn, object):
@@ -1417,12 +1533,12 @@
         """
         parent_pipe, self.child_pipe = multiprocessing.Pipe()
         
-        super(MultiprocessingMixInWithPipe,
-              self).process_request(request, client_address)
+        proc = MultiprocessingMixIn.process_request(self, request,
+                                                    client_address)
         self.child_pipe.close()
-        self.add_pipe(parent_pipe)
+        self.add_pipe(parent_pipe, proc)
     
-    def add_pipe(self, parent_pipe):
+    def add_pipe(self, parent_pipe, proc):
         """Dummy function; override as necessary"""
         raise NotImplementedError
 
@@ -1516,17 +1632,21 @@
     def server_activate(self):
         if self.enabled:
             return socketserver.TCPServer.server_activate(self)
+    
     def enable(self):
         self.enabled = True
-    def add_pipe(self, parent_pipe):
+    
+    def add_pipe(self, parent_pipe, proc):
         # Call "handle_ipc" for both data and EOF events
         gobject.io_add_watch(parent_pipe.fileno(),
                              gobject.IO_IN | gobject.IO_HUP,
                              functools.partial(self.handle_ipc,
-                                               parent_pipe = parent_pipe))
-        
+                                               parent_pipe =
+                                               parent_pipe,
+                                               proc = proc))
+    
     def handle_ipc(self, source, condition, parent_pipe=None,
-                   client_object=None):
+                   proc = None, client_object=None):
         condition_names = {
             gobject.IO_IN: "IN",   # There is data to read.
             gobject.IO_OUT: "OUT", # Data can be written (without
@@ -1541,8 +1661,10 @@
                                        for cond, name in
                                        condition_names.iteritems()
                                        if cond & condition)
-        # error or the other end of multiprocessing.Pipe has closed
+        # error, or the other end of multiprocessing.Pipe has closed
         if condition & (gobject.IO_ERR | condition & gobject.IO_HUP):
+            # Wait for other process to exit
+            proc.join()
             return False
         
         # Read a request from the child
@@ -1562,31 +1684,39 @@
                             "dress: %s", fpr, address)
                 if self.use_dbus:
                     # Emit D-Bus signal
-                    mandos_dbus_service.ClientNotFound(fpr, address[0])
+                    mandos_dbus_service.ClientNotFound(fpr,
+                                                       address[0])
                 parent_pipe.send(False)
                 return False
             
             gobject.io_add_watch(parent_pipe.fileno(),
                                  gobject.IO_IN | gobject.IO_HUP,
                                  functools.partial(self.handle_ipc,
-                                                   parent_pipe = parent_pipe,
-                                                   client_object = client))
+                                                   parent_pipe =
+                                                   parent_pipe,
+                                                   proc = proc,
+                                                   client_object =
+                                                   client))
             parent_pipe.send(True)
-            # remove the old hook in favor of the new above hook on same fileno
+            # remove the old hook in favor of the new above hook on
+            # same fileno
             return False
         if command == 'funcall':
             funcname = request[1]
             args = request[2]
             kwargs = request[3]
             
-            parent_pipe.send(('data', getattr(client_object, funcname)(*args, **kwargs)))
+            parent_pipe.send(('data', getattr(client_object,
+                                              funcname)(*args,
+                                                         **kwargs)))
         
         if command == 'getattr':
             attrname = request[1]
             if callable(client_object.__getattribute__(attrname)):
                 parent_pipe.send(('function',))
             else:
-                parent_pipe.send(('data', client_object.__getattribute__(attrname)))
+                parent_pipe.send(('data', client_object
+                                  .__getattribute__(attrname)))
         
         if command == 'setattr':
             attrname = request[1]
@@ -1881,8 +2011,11 @@
     # End of Avahi example code
     if use_dbus:
         try:
-            bus_name = dbus.service.BusName("se.bsnet.fukt.Mandos",
+            bus_name = dbus.service.BusName("se.recompile.Mandos",
                                             bus, do_not_queue=True)
+            old_bus_name = (dbus.service.BusName
+                            ("se.bsnet.fukt.Mandos", bus,
+                             do_not_queue=True))
         except dbus.exceptions.NameExistsException as e:
             logger.error(unicode(e) + ", disabling D-Bus")
             use_dbus = False
@@ -1901,7 +2034,8 @@
     
     client_class = Client
     if use_dbus:
-        client_class = functools.partial(ClientDBus, bus = bus)
+        client_class = functools.partial(ClientDBusTransitional,
+                                         bus = bus)
     def client_config_items(config, section):
         special_settings = {
             "approved_by_default":
@@ -1946,7 +2080,7 @@
             """A D-Bus proxy object"""
             def __init__(self):
                 dbus.service.Object.__init__(self, bus, "/")
-            _interface = "se.bsnet.fukt.Mandos"
+            _interface = "se.recompile.Mandos"
             
             @dbus.service.signal(_interface, signature="o")
             def ClientAdded(self, objpath):
@@ -1994,12 +2128,15 @@
             
             del _interface
         
-        mandos_dbus_service = MandosDBusService()
+        class MandosDBusServiceTransitional(MandosDBusService):
+            __metaclass__ = AlternateDBusNamesMetaclass
+        mandos_dbus_service = MandosDBusServiceTransitional()
     
     def cleanup():
         "Cleanup function; run on exit"
         service.cleanup()
         
+        multiprocessing.active_children()
         while tcp_server.clients:
             client = tcp_server.clients.pop()
             if use_dbus:
@@ -2009,7 +2146,8 @@
             client.disable(quiet=True)
             if use_dbus:
                 # Emit D-Bus signal
-                mandos_dbus_service.ClientRemoved(client.dbus_object_path,
+                mandos_dbus_service.ClientRemoved(client
+                                                  .dbus_object_path,
                                                   client.name)
     
     atexit.register(cleanup)

=== modified file 'mandos-clients.conf.xml'
--- mandos-clients.conf.xml	2011-09-26 19:34:23 +0000
+++ mandos-clients.conf.xml	2011-10-10 20:29:58 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos-clients.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/clients.conf</filename>">
-<!ENTITY TIMESTAMP "2011-09-24">
+<!ENTITY TIMESTAMP "2011-10-10">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -20,14 +20,14 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@fukt.bsnet.se</email>
+	  <email>belorn@recompile.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@fukt.bsnet.se</email>
+	  <email>teddy@recompile.se</email>
 	</address>
       </author>
     </authorgroup>
@@ -190,7 +190,7 @@
 	  </para>
 	  <para>
 	    Extended timeout is an added timeout that is given once
-	    after a password has been sent sucessfully to a client.
+	    after a password has been sent successfully to a client.
 	    The timeout is by default longer than the normal timeout,
 	    and is used for handling the extra long downtime while a
 	    machine is booting up.  Time to take into consideration

=== modified file 'mandos-ctl'
--- mandos-ctl	2011-09-18 14:28:47 +0000
+++ mandos-ctl	2011-10-09 17:36:01 +0000
@@ -3,8 +3,8 @@
 # 
 # Mandos Monitor - Control and monitor the Mandos server
 # 
-# Copyright © 2008-2010 Teddy Hogeborn
-# Copyright © 2008-2010 Björn Påhlsson
+# Copyright © 2008-2011 Teddy Hogeborn
+# Copyright © 2008-2011 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -19,7 +19,7 @@
 # You should have received a copy of the GNU General Public License
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
 # 
-# Contact the authors at <mandos@fukt.bsnet.se>.
+# Contact the authors at <mandos@recompile.se>.
 # 
 
 from __future__ import (division, absolute_import, print_function,
@@ -55,12 +55,12 @@
     "ExtendedTimeout" : "Extended Timeout"
     }
 defaultkeywords = ("Name", "Enabled", "Timeout", "LastCheckedOK")
-domain = "se.bsnet.fukt"
+domain = "se.recompile"
 busname = domain + ".Mandos"
 server_path = "/"
 server_interface = domain + ".Mandos"
 client_interface = domain + ".Mandos.Client"
-version = "1.3.1"
+version = "1.4.0"
 
 def timedelta_to_milliseconds(td):
     """Convert a datetime.timedelta object to milliseconds"""

=== modified file 'mandos-ctl.xml'
--- mandos-ctl.xml	2011-09-18 14:28:47 +0000
+++ mandos-ctl.xml	2011-10-05 16:00:56 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-ctl">
-<!ENTITY TIMESTAMP "2011-08-08">
+<!ENTITY TIMESTAMP "2011-10-03">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -19,14 +19,14 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@fukt.bsnet.se</email>
+	  <email>belorn@recompile.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@fukt.bsnet.se</email>
+	  <email>teddy@recompile.se</email>
 	</address>
       </author>
     </authorgroup>

=== modified file 'mandos-keygen'
--- mandos-keygen	2011-08-17 22:27:13 +0000
+++ mandos-keygen	2011-10-09 17:36:01 +0000
@@ -18,10 +18,10 @@
 # You should have received a copy of the GNU General Public License
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
 # 
-# Contact the authors at <mandos@fukt.bsnet.se>.
+# Contact the authors at <mandos@recompile.se>.
 # 
 
-VERSION="1.3.1"
+VERSION="1.4.0"
 
 KEYDIR="/etc/keys/mandos"
 KEYTYPE=DSA

=== modified file 'mandos-keygen.xml'
--- mandos-keygen.xml	2011-08-08 21:12:37 +0000
+++ mandos-keygen.xml	2011-10-05 16:00:56 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-keygen">
-<!ENTITY TIMESTAMP "2011-08-08">
+<!ENTITY TIMESTAMP "2011-10-03">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -19,14 +19,14 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@fukt.bsnet.se</email>
+	  <email>belorn@recompile.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@fukt.bsnet.se</email>
+	  <email>teddy@recompile.se</email>
 	</address>
       </author>
     </authorgroup>

=== modified file 'mandos-monitor'
--- mandos-monitor	2011-09-18 14:28:47 +0000
+++ mandos-monitor	2011-10-09 17:36:01 +0000
@@ -19,7 +19,7 @@
 # You should have received a copy of the GNU General Public License
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
 # 
-# Contact the authors at <mandos@fukt.bsnet.se>.
+# Contact the authors at <mandos@recompile.se>.
 # 
 
 from __future__ import (division, absolute_import, print_function,
@@ -49,10 +49,10 @@
 logging.getLogger('dbus.proxies').setLevel(logging.CRITICAL)
 
 # Some useful constants
-domain = 'se.bsnet.fukt'
+domain = 'se.recompile'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.3.1"
+version = "1.4.0"
 
 # Always run in monochrome mode
 urwid.curses_display.curses.has_colors = lambda : False

=== modified file 'mandos-monitor.xml'
--- mandos-monitor.xml	2011-08-08 21:12:37 +0000
+++ mandos-monitor.xml	2011-10-05 16:00:56 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-monitor">
-<!ENTITY TIMESTAMP "2011-08-08">
+<!ENTITY TIMESTAMP "2011-10-03">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -19,14 +19,14 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@fukt.bsnet.se</email>
+	  <email>belorn@recompile.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@fukt.bsnet.se</email>
+	  <email>teddy@recompile.se</email>
 	</address>
       </author>
     </authorgroup>

=== modified file 'mandos.conf.xml'
--- mandos.conf.xml	2011-08-08 21:12:37 +0000
+++ mandos.conf.xml	2011-10-05 16:00:56 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/mandos.conf</filename>">
-<!ENTITY TIMESTAMP "2011-08-08">
+<!ENTITY TIMESTAMP "2011-10-03">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -20,14 +20,14 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@fukt.bsnet.se</email>
+	  <email>belorn@recompile.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@fukt.bsnet.se</email>
+	  <email>teddy@recompile.se</email>
 	</address>
       </author>
     </authorgroup>

=== modified file 'mandos.lsm'
--- mandos.lsm	2011-07-27 17:58:27 +0000
+++ mandos.lsm	2011-10-09 17:36:01 +0000
@@ -1,20 +1,20 @@
 Begin4
 Title:		Mandos
-Version:	1.3.1
-Entered-date:	2011-07-27
+Version:	1.4.0
+Entered-date:	2011-10-09
 Description:	The Mandos system allows computers to have encrypted
 root file systems and at the same time be capable of remote and/or
 unattended reboots.
 Keywords:	boot, encryption, luks, cryptsetup, network, openpgp,
 tls, dm-crypt
-Author:		teddy@fukt.bsnet.se (Teddy Hogeborn),
-		belorn@fukt.bsnet.se (Björn Påhlsson)
-Maintained-by:	teddy@fukt.bsnet.se (Teddy Hogeborn),
-		belorn@fukt.bsnet.se (Björn Påhlsson)
-Primary-site: http://www.fukt.bsnet.se/mandos
-	      136K mandos_1.3.1.orig.tar.gz
-Alternate-site: ftp://ftp.fukt.bsnet.se/pub/mandos
-		136K mandos_1.3.1.orig.tar.gz
+Author:		teddy@recompile.se (Teddy Hogeborn),
+		belorn@recompile.se (Björn Påhlsson)
+Maintained-by:	teddy@recompile.se (Teddy Hogeborn),
+		belorn@recompile.se (Björn Påhlsson)
+Primary-site: http://www.recompile.se/mandos
+	      137K mandos_1.4.0.orig.tar.gz
+Alternate-site: ftp://ftp.recompile.se/pub/mandos
+		137K mandos_1.4.0.orig.tar.gz
 Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.6, and
 various other libraries.  While made for Debian GNU/Linux, it is
 probably portable to other distributions, but not other Unixes.

=== modified file 'mandos.xml'
--- mandos.xml	2011-09-18 14:28:47 +0000
+++ mandos.xml	2011-10-05 16:00:56 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos">
-<!ENTITY TIMESTAMP "2011-08-08">
+<!ENTITY TIMESTAMP "2011-10-03">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -19,14 +19,14 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@fukt.bsnet.se</email>
+	  <email>belorn@recompile.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@fukt.bsnet.se</email>
+	  <email>teddy@recompile.se</email>
 	</address>
       </author>
     </authorgroup>

=== modified file 'plugin-runner.c'
--- plugin-runner.c	2011-07-16 00:29:19 +0000
+++ plugin-runner.c	2011-10-09 12:32:13 +0000
@@ -2,8 +2,8 @@
 /*
  * Mandos plugin runner - Run Mandos plugins
  *
- * Copyright © 2008-2010 Teddy Hogeborn
- * Copyright © 2008-2010 Björn Påhlsson
+ * Copyright © 2008-2011 Teddy Hogeborn
+ * Copyright © 2008-2011 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -19,7 +19,7 @@
  * along with this program.  If not, see
  * <http://www.gnu.org/licenses/>.
  * 
- * Contact the authors at <mandos@fukt.bsnet.se>.
+ * Contact the authors at <mandos@recompile.se>.
  */
 
 #define _GNU_SOURCE		/* TEMP_FAILURE_RETRY(), getline(),
@@ -79,7 +79,7 @@
 #define AFILE "/conf/conf.d/mandos/plugin-runner.conf"
 
 const char *argp_program_version = "plugin-runner " VERSION;
-const char *argp_program_bug_address = "<mandos@fukt.bsnet.se>";
+const char *argp_program_bug_address = "<mandos@recompile.se>";
 
 typedef struct plugin{
   char *name;			/* can be NULL or any plugin name */

=== modified file 'plugin-runner.xml'
--- plugin-runner.xml	2011-08-08 21:12:37 +0000
+++ plugin-runner.xml	2011-10-05 16:56:06 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "plugin-runner">
-<!ENTITY TIMESTAMP "2011-08-08">
+<!ENTITY TIMESTAMP "2011-10-05">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -19,14 +19,14 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@fukt.bsnet.se</email>
+	  <email>belorn@recompile.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@fukt.bsnet.se</email>
+	  <email>teddy@recompile.se</email>
 	</address>
       </author>
     </authorgroup>
@@ -261,7 +261,7 @@
 	    Disable the plugin named
 	    <replaceable>PLUGIN</replaceable>.  The plugin will not be
 	    started.
-	  </para>	
+	  </para>
 	</listitem>
       </varlistentry>
       

=== modified file 'plugins.d/askpass-fifo.c'
--- plugins.d/askpass-fifo.c	2011-07-13 02:24:39 +0000
+++ plugins.d/askpass-fifo.c	2011-10-05 16:00:56 +0000
@@ -19,7 +19,7 @@
  * along with this program.  If not, see
  * <http://www.gnu.org/licenses/>.
  * 
- * Contact the authors at <mandos@fukt.bsnet.se>.
+ * Contact the authors at <mandos@recompile.se>.
  */
 
 #define _GNU_SOURCE		/* TEMP_FAILURE_RETRY() */

=== modified file 'plugins.d/askpass-fifo.xml'
--- plugins.d/askpass-fifo.xml	2011-08-08 21:12:37 +0000
+++ plugins.d/askpass-fifo.xml	2011-10-05 16:00:56 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "askpass-fifo">
-<!ENTITY TIMESTAMP "2011-08-08">
+<!ENTITY TIMESTAMP "2011-10-03">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -19,14 +19,14 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@fukt.bsnet.se</email>
+	  <email>belorn@recompile.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@fukt.bsnet.se</email>
+	  <email>teddy@recompile.se</email>
 	</address>
       </author>
     </authorgroup>

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2011-08-07 14:49:02 +0000
+++ plugins.d/mandos-client.c	2011-10-05 16:00:56 +0000
@@ -26,7 +26,7 @@
  * along with this program.  If not, see
  * <http://www.gnu.org/licenses/>.
  * 
- * Contact the authors at <mandos@fukt.bsnet.se>.
+ * Contact the authors at <mandos@recompile.se>.
  */
 
 /* Needed by GPGME, specifically gpgme_data_seek() */
@@ -127,7 +127,7 @@
 bool debug = false;
 static const char mandos_protocol_version[] = "1";
 const char *argp_program_version = "mandos-client " VERSION;
-const char *argp_program_bug_address = "<mandos@fukt.bsnet.se>";
+const char *argp_program_bug_address = "<mandos@recompile.se>";
 static const char sys_class_net[] = "/sys/class/net";
 char *connect_to = NULL;
 

=== modified file 'plugins.d/mandos-client.xml'
--- plugins.d/mandos-client.xml	2011-08-08 21:12:37 +0000
+++ plugins.d/mandos-client.xml	2011-10-05 16:00:56 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-client">
-<!ENTITY TIMESTAMP "2011-08-08">
+<!ENTITY TIMESTAMP "2011-10-03">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -19,14 +19,14 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@fukt.bsnet.se</email>
+	  <email>belorn@recompile.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@fukt.bsnet.se</email>
+	  <email>teddy@recompile.se</email>
 	</address>
       </author>
     </authorgroup>

=== modified file 'plugins.d/password-prompt.c'
--- plugins.d/password-prompt.c	2011-07-27 17:58:27 +0000
+++ plugins.d/password-prompt.c	2011-10-09 12:32:13 +0000
@@ -2,8 +2,8 @@
 /*
  * Password-prompt - Read a password from the terminal and print it
  * 
- * Copyright © 2008-2010 Teddy Hogeborn
- * Copyright © 2008-2010 Björn Påhlsson
+ * Copyright © 2008-2011 Teddy Hogeborn
+ * Copyright © 2008-2011 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -19,7 +19,7 @@
  * along with this program.  If not, see
  * <http://www.gnu.org/licenses/>.
  * 
- * Contact the authors at <mandos@fukt.bsnet.se>.
+ * Contact the authors at <mandos@recompile.se>.
  */
 
 #define _GNU_SOURCE		/* getline(), asprintf() */
@@ -67,7 +67,7 @@
 int signal_received;
 bool debug = false;
 const char *argp_program_version = "password-prompt " VERSION;
-const char *argp_program_bug_address = "<mandos@fukt.bsnet.se>";
+const char *argp_program_bug_address = "<mandos@recompile.se>";
 
 /* Needed for conflict resolution */
 const char plymouth_name[] = "plymouthd";

=== modified file 'plugins.d/password-prompt.xml'
--- plugins.d/password-prompt.xml	2011-08-08 21:12:37 +0000
+++ plugins.d/password-prompt.xml	2011-10-05 16:00:56 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "password-prompt">
-<!ENTITY TIMESTAMP "2011-08-08">
+<!ENTITY TIMESTAMP "2011-10-03">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -19,14 +19,14 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@fukt.bsnet.se</email>
+	  <email>belorn@recompile.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@fukt.bsnet.se</email>
+	  <email>teddy@recompile.se</email>
 	</address>
       </author>
     </authorgroup>

=== modified file 'plugins.d/plymouth.c'
--- plugins.d/plymouth.c	2011-07-13 02:24:39 +0000
+++ plugins.d/plymouth.c	2011-10-05 16:00:56 +0000
@@ -19,7 +19,7 @@
  * along with this program.  If not, see
  * <http://www.gnu.org/licenses/>.
  * 
- * Contact the authors at <mandos@fukt.bsnet.se>.
+ * Contact the authors at <mandos@recompile.se>.
  */
 
 #define _GNU_SOURCE		/* asprintf(), TEMP_FAILURE_RETRY() */
@@ -54,15 +54,17 @@
 #include <stdarg.h>		/* va_list, va_start(), ... */
 
 sig_atomic_t interrupted_by_signal = 0;
-const char plymouth_pid[] = "/dev/.initramfs/plymouth.pid";
+
+/* Used by Ubuntu 11.04 (Natty Narwahl) */
+const char plymouth_old_pid[] = "/dev/.initramfs/plymouth.pid";
+/* Used by Ubuntu 11.10 (Oneiric Ocelot) */
+const char plymouth_pid[] = "/run/initramfs/plymouth.pid";
+
 const char plymouth_path[] = "/bin/plymouth";
 const char plymouthd_path[] = "/sbin/plymouthd";
 const char *plymouthd_default_argv[] = {"/sbin/plymouthd",
 					"--mode=boot",
 					"--attach-to-session",
-					"--pid-file="
-					"/dev/.initramfs/"
-					"plymouth.pid",
 					NULL };
 
 static void termination_handler(__attribute__((unused))int signum){
@@ -260,8 +262,9 @@
 
 pid_t get_pid(void){
   int ret;
+  uintmax_t maxvalue = 0;
   FILE *pidfile = fopen(plymouth_pid, "r");
-  uintmax_t maxvalue = 0;
+  /* Try the new pid file location */
   if(pidfile != NULL){
     ret = fscanf(pidfile, "%" SCNuMAX, &maxvalue);
     if(ret != 1){
@@ -269,6 +272,18 @@
     }
     fclose(pidfile);
   }
+  /* Try the old pid file location */
+  if(maxvalue == 0){
+    pidfile = fopen(plymouth_pid, "r");
+    if(pidfile != NULL){
+      ret = fscanf(pidfile, "%" SCNuMAX, &maxvalue);
+      if(ret != 1){
+	maxvalue = 0;
+      }
+      fclose(pidfile);
+    }
+  }
+  /* Look for a plymouth process */
   if(maxvalue == 0){
     struct dirent **direntries = NULL;
     ret = scandir("/proc", &direntries, is_plymouth, alphasort);

=== modified file 'plugins.d/plymouth.xml'
--- plugins.d/plymouth.xml	2011-08-08 21:12:37 +0000
+++ plugins.d/plymouth.xml	2011-10-05 16:00:56 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "plymouth">
-<!ENTITY TIMESTAMP "2011-08-08">
+<!ENTITY TIMESTAMP "2011-10-03">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -19,14 +19,14 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@fukt.bsnet.se</email>
+	  <email>belorn@recompile.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@fukt.bsnet.se</email>
+	  <email>teddy@recompile.se</email>
 	</address>
       </author>
     </authorgroup>

=== modified file 'plugins.d/splashy.c'
--- plugins.d/splashy.c	2011-07-13 02:24:39 +0000
+++ plugins.d/splashy.c	2011-10-05 16:00:56 +0000
@@ -19,7 +19,7 @@
  * along with this program.  If not, see
  * <http://www.gnu.org/licenses/>.
  * 
- * Contact the authors at <mandos@fukt.bsnet.se>.
+ * Contact the authors at <mandos@recompile.se>.
  */
 
 #define _GNU_SOURCE		/* TEMP_FAILURE_RETRY(), asprintf() */

=== modified file 'plugins.d/splashy.xml'
--- plugins.d/splashy.xml	2011-08-08 21:12:37 +0000
+++ plugins.d/splashy.xml	2011-10-05 16:00:56 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "splashy">
-<!ENTITY TIMESTAMP "2011-08-08">
+<!ENTITY TIMESTAMP "2011-10-03">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -19,14 +19,14 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@fukt.bsnet.se</email>
+	  <email>belorn@recompile.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@fukt.bsnet.se</email>
+	  <email>teddy@recompile.se</email>
 	</address>
       </author>
     </authorgroup>

=== modified file 'plugins.d/usplash.c'
--- plugins.d/usplash.c	2011-07-13 02:24:39 +0000
+++ plugins.d/usplash.c	2011-10-05 16:00:56 +0000
@@ -19,7 +19,7 @@
  * along with this program.  If not, see
  * <http://www.gnu.org/licenses/>.
  * 
- * Contact the authors at <mandos@fukt.bsnet.se>.
+ * Contact the authors at <mandos@recompile.se>.
  */
 
 #define _GNU_SOURCE		/* asprintf(), TEMP_FAILURE_RETRY() */

=== modified file 'plugins.d/usplash.xml'
--- plugins.d/usplash.xml	2011-08-08 21:12:37 +0000
+++ plugins.d/usplash.xml	2011-10-05 16:00:56 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "usplash">
-<!ENTITY TIMESTAMP "2011-08-08">
+<!ENTITY TIMESTAMP "2011-10-03">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -19,14 +19,14 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@fukt.bsnet.se</email>
+	  <email>belorn@recompile.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@fukt.bsnet.se</email>
+	  <email>teddy@recompile.se</email>
 	</address>
       </author>
     </authorgroup>

